#define INCL_DOSSEMAPHORES
#define INCL_DOSPROCESS
#define INCL_DOSMISC
#include <os2.h>

#include "config.h"
#include "global.h"
#include "../engine/thread.h"

struct thread_struct {
  gogo_thread_func func;
  void *data;
};

void start_thread(void * args)
{
  struct thread_struct * ts = (struct thread_struct *)args;
  ts->func(ts->data);
  free(args);
}

int
gogo_get_cpu_count(int *pCPUs, int *pTHREADs)
{
        const int QSV_NUMPROCESSORS = 26;
        APIRET apiretRc = 0;
        int nCPU = 1;

        if(*pCPUs == 0){
		/* auto */
        	apiretRc = DosQuerySysInfo(QSV_NUMPROCESSORS, QSV_NUMPROCESSORS, &nCPU, sizeof(nCPU));
        	if(apiretRc != 0) nCPU = 1;
        	*pCPUs = nCPU;
        	*pTHREADs = (nCPU > 1)? nCPU: 1;
	}else{
		/* manual */
        	*pTHREADs = (*pCPUs > 1)? *pCPUs: 1;
	}

        return 0;
}

int
gogo_create_thread(gogo_thread* pThread, gogo_thread_func func, void *data)
{
        int pid;
        struct thread_struct * ts = malloc(sizeof(struct thread_struct));
        ts->func = func;
        ts->data = data;
        pid = _beginthread(start_thread, NULL, 65536, (void *)ts);
        return pid;
}
